    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * ------------------------
    028     * CategoryLabelEntity.java
    029     * ------------------------
    030     * (C) Copyright 2006-2011, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 02-Oct-2006 : Version 1 (DG);
    038     * 13-Nov-2007 : Added equals() and hashCode() methods (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.entity;
    043
    044    import java.awt.Shape;
    045
    046    import org.jfree.chart.HashUtilities;
    047    import org.jfree.chart.axis.CategoryAxis;
    048    import org.jfree.util.ObjectUtilities;
    049
    050    /**
    051     * An entity to represent the labels on a {@link CategoryAxis}.
    052     *
    053     * @since 1.0.3
    054     */
    055    public class CategoryLabelEntity extends TickLabelEntity {
    056
    057        /** The category key. */
    058        private Comparable key;
    059
    060        /**
    061         * Creates a new entity.
    062         *
    063         * @param key  the category key.
    064         * @param area  the hotspot.
    065         * @param toolTipText  the tool tip text.
    066         * @param urlText  the URL text.
    067         */
    068        public CategoryLabelEntity(Comparable key, Shape area,
    069                String toolTipText, String urlText) {
    070            super(area, toolTipText, urlText);
    071            this.key = key;
    072        }
    073
    074        /**
    075         * Returns the category key.
    076         *
    077         * @return The category key.
    078         */
    079        public Comparable getKey() {
    080            return this.key;
    081        }
    082
    083        /**
    084         * Tests this instance for equality with an arbitrary object.
    085         *
    086         * @param obj  the object (<code>null</code> permitted).
    087         *
    088         * @return A boolean.
    089         */
    090        public boolean equals(Object obj) {
    091            if (obj == this) {
    092                return true;
    093            }
    094            if (!(obj instanceof CategoryLabelEntity)) {
    095                return false;
    096            }
    097            CategoryLabelEntity that = (CategoryLabelEntity) obj;
    098            if (!ObjectUtilities.equal(this.key, that.key)) {
    099                return false;
    100            }
    101            return super.equals(obj);
    102        }
    103
    104        /**
    105         * Returns a hash code for this instance.
    106         *
    107         * @return A hash code.
    108         */
    109        public int hashCode() {
    110            int result = super.hashCode();
    111            result = HashUtilities.hashCode(result, this.key);
    112            return result;
    113        }
    114
    115        /**
    116         * Returns a string representation of this entity.  This is primarily
    117         * useful for debugging.
    118         *
    119         * @return A string representation of this entity.
    120         */
    121        public String toString() {
    122            StringBuffer buf = new StringBuffer("CategoryLabelEntity: ");
    123            buf.append("category=");
    124            buf.append(this.key);
    125            buf.append(", tooltip=" + getToolTipText());
    126            buf.append(", url=" + getURLText());
    127            return buf.toString();
    128        }
    129    }